Vector = {}
function Vector:new(x,y,z)
  local self = {x=x, y=y, z=z}
  local mt = {__index = Vector}
  setmetatable( self, mt )

  function mt.__tostring(v)
    return ( "(" .. v.x .. ", " .. v.y .. ", " .. v.z .. ")" )
  end
  function mt.__add(v1, v2)
    return Vector:new( v1.x+v2.x, v1.y+v2.y, v1.z+v2.z)
  end
  function mt.__sub(v1, v2)
    return Vector:new( v1.x-v2.x, v1.y-v2.y, v1.z-v2.z)
  end
  function mt.__unm(v)
    return Vector:new(-v.x, -v.y, -v.z)
  end
  function mt.__mul(v1, v2)
    if tonumber(v2) then
      return Vector:new(v1.x*v2, v1.y*v2, v1.z*v2)
    else
      return ( v1.x*v2.x + v1.y*v2.y + v1.z*v2.z )
    end
  end

  function self.print()
    print(self)
  end
  function self.X(v)
    return Vector:new(
      self.y * v.z - self.z * v.y,
      self.z * v.x - self.x * v.z,
      self.x * v.y - self.y * v.x)
  end
  function self.length()
    return math.sqrt(self * self)
  end
  function self.normalize()
    a = self.length()
    if a ~= 0 then
      return self*(1.0/a)
    else
      return self
    end
  end
  function self.normalize_()
    a = self.length()
    if a ~= 0 then
      self.x = self.x / a
      self.y = self.y / a
      self.z = self.z / a
    end
    return self
  end

  return self
end
